<template>
  <v-container>
    <v-dialog v-model="showDialog" max-width="520" persistent>
      <v-card v-if="processType === 'setpending'">
        <v-card-title v-if="item">
          Are you sure you want to apply again for
          {{ item.netobject }}</v-card-title
        >
        <v-divider></v-divider>
        <v-card-actions>
          <v-text-field v-if="loadingInDialog" loading disabled></v-text-field>
          <UIAlert
            class="mt-4"
            v-if="errorInDialog && !loadingInDialog"
            v-bind:isSuccessful="!errorInDialog"
            v-bind:message="$store.state.application.httpErrorMessage"
          />
          <v-spacer></v-spacer>
          <v-btn
            color="blue darken-1"
            text
            @click="
              $emit('child-object', {
                closeDialog: true,
                netobjectChanged: false
              })
            "
          >
            Cancel
          </v-btn>
          <v-btn color="blue darken-1" text @click="reclaimRequest">
            yes
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-container>
</template>
<script setup lang="ts">
/*
 * This file is Free Software under GNU Affero General Public License v >= 3.0
 * without warranty, see README.md and license for details.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 *
 * SPDX-FileCopyrightText: 2020 nic.at GmbH <https://nic.at>
 * Software-Engineering: 2020 Intevation GmbH <https://intevation.de>
 *
 * Author(s):
 * 2021, 2022 Fadi Abbud <fadi.abbud@intevation.de>
 */
import { HTTP } from "@/lib/http";
import { defineAsyncComponent, ref } from "vue";

const UIAlert = defineAsyncComponent(() =>
  import("@/components/ui/UIAlert.vue")
);

const props = defineProps({
  processType: String,
  item: Object
});
const emit = defineEmits(["child-object"]);

const showDialog = true;
// Re-Claim Netobject
const loadingInDialog = ref(false);
const errorInDialog = ref(false);
const reclaimRequest = () => {
  loadingInDialog.value = true;
  HTTP.put(
    `/organisations/${props.item?.organisation_id}${
      props.item?.type === "asn"
        ? "/asns/" + props.item?.asn_id
        : props.item?.type === "network"
        ? "/networks/" + props.item?.network_id
        : props.item?.type === "ripehandle"
        ? "/ripe_handles/" + props.item?.ripe_org_hdl_id
        : "/fqdns/" + props.item?.fqdn_id
    }`,
    {
      approval: "pending"
    }
  )
    .then(() => {
      emit("child-object", {
        closeDialog: true,
        netobjectChanged: true,
        newValue: "pending"
      });
    })
    .catch(() => {
      errorInDialog.value = true;
    })
    .finally(() => {
      loadingInDialog.value = false;
    });
};
</script>
